import { createRouter, createWebHistory } from "vue-router";
import { defineComponent } from "vue";

/**
 * @type {import("vue-router").RouteRecordRaw[]}
 */
const routes = [
  {
    path: "/",
    name: "home",
    component: () =>
      import(/* webpackChunkName: "about" */ "../views/queue.vue"),
  },
  {
    path: "/sdk",
    name: "sdk",
    component: defineComponent({
      name: "DynamicComponent",
      render() {
        return <router-view></router-view>;
      },
    }),
    children: [
      {
        path: "queue",
        name: "queue",
        component: () =>
          import(/* webpackChunkName: "queue" */ "../views/queue.vue"),
      },
      {
        path: "async",
        name: "async",
        component: () =>
          import(/* webpackChunkName: "async" */ "../views/async.vue"),
      },
      {
        path: "storage",
        name: "storage",
        component: () =>
          import(/* webpackChunkName: "storage" */ "../views/storage.vue"),
      },
      {
        path: "flexible",
        name: "flexible",
        component: () =>
          import(/* webpackChunkName: "flexible" */ "../views/flexible.vue"),
      },
      {
        path: "",
        redirect: {
          name: "queue",
        },
      },
      {
        path: "/:pathMatch(.*)",
        redirect: {
          name: "queue",
        },
      },
    ],
  },
];

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes,
});

export default router;
